import DB from "./node";

const log = (prms: Promise<any>, pref = "VALUE") => prms.then(val => console.log(pref + ": ", val));

(async () => {
   const db = new DB("http://localhost:5000", "test_database", "access87125t487123897458725123");
   console.log("Start!");
   let s1 = await db.subscribe("/", "set", (data) => console.log("SET  :", data));
   let s2 = await db.subscribe("/", "push", (data) => console.log("PUSH :", data));

   await log(db.get("/"));
   await db.set("/test", {});
   await log(db.get("/"));
   await db.set("/test/data1", 123);
   await log(db.get("/"));
   await db.push("/test/push", "Push01");
   await db.push("/test/push", "Push02");
   await db.push("/test/push", "Push03");
   await log(db.get("/"));
   await log(db.keys("/test/push"), "KEYS")
   await db.set("/", null);
   await log(db.get("/"));
   console.log("End Test 1");

   await db.set("/test/data1", { data: "Test" });
   await log(db.get("/"));

   await db.set("/test/data1", null);
   await log(db.get("/"));

   console.log("End Test 2");

   const coll1 = db.collection("/collection1");
   await coll1.set("/value1", { value: 1 });
   await log(coll1.get([]), "CGET");
   await log(db.get([]));

   console.log("End Test 3");


   await db.set("/", { Hallo: "WELT" })
   await db.set("/Hallo", { Hallo: "WELT" })
   setTimeout(() => {
      s1.unsubscribe();
      s2.unsubscribe();
      console.log("End!");
      process.exit();
   }, 1000);
})()
   .catch(err => console.error(err));